#ifndef HASH
#define HASH

#include <map>

#include "Platform.hpp"
#include "Board.hpp"
#include "Evaluation.hpp"
#include "Move.hpp"

namespace Hash {
    UNumber64 get64(const Board&);

	class Record {
	public:
		UNumber depth;
		Score score;
		enum N { SCORE_REAL, SCORE_MIN, SCORE_MAX } nature;
		std::list<Move> pv;
	};

	// todo: max size
	class Table {
	public: 
		void add(const Board&, Record);
		void renew(const Board&, Record);
		bool has(const Board&);
		void remove(const Board&);
		Record get(const Board&);
		UNumber size();

		static Table empty();
	private:
		std::map<UNumber64, Record> records;
	};
}

#endif
